/*(LGPL)
-----------------------------------------------------------------
	zs_types.h - ZeeSpace Types
-----------------------------------------------------------------
 * Copyright (C) 2005 David Olofson
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	ZS_TYPES_H
#define	ZS_TYPES_H

typedef struct ZS_Surface ZS_Surface;
typedef struct ZS_Pipe ZS_Pipe;


/* Single RGBAIZ pixel */
typedef struct
{
	unsigned char	r, g, b, a;
	unsigned short	i;		/* fixp 8:8 */
	unsigned short	z;		/* fixp 8:8 */
} ZS_Pixel;


/* Rectangle */
typedef struct
{
	int		x, y;
	unsigned	w, h;
} ZS_Rect;


/* ZeeSpace state */
typedef struct ZS_State
{
	int		bufw;		/* # of pixels in scratch and pipebuf */
	ZS_Pixel	*scratch;	/* Rendering scratch pad (one pixel row) */
	ZS_Pixel	*pipebuf;	/* Intermediate pipeline buffer (one pixel row) */
	int		refcount;
	unsigned	rnd1, rnd2, rbal;
} ZS_State;

#endif /* ZS_TYPES_H */
